Subject: RE: Question on 'v32v2' utility when using MPP version MM5V3.2
From: "John G. Michalakes" <[email-masked]>
To: "'Houjun Wang'" <[email-masked]>
Date: Thu, 14 Oct 1999 03:12:02 -0600

On Wednesday, October 13, 1999 9:10 PM, Houjun Wang 
[SMTP:[email-masked]] wrote:
> Dear Dr. John Michalakes:
>
> The 'v32v2' utility works fine if I don't use the MPP version of MM5V3.2.
> But 'v32v2' utility doesn't work when using the MPP version of MM5V3.2 -
> I used it on Linux machines. This might be simply because that the MPP
> version of MM5V3.2 calls RSL_WRITE_MM5V3_SM_HEADER etc. Since I don't have
> a good understanding of these subroutines (and C), could I ask whether
> someone has a revised version of 'v32v2' utility that can handle this
> problem? Thanks.
>
> Regards,
>
> Houjun Wang
> Department of Meteorology
> Penn State university
>
> [email-masked]
> 814-863-8601

Dear Houjun,

I think you have uncovered a bug. Fortunately I think this will be easy to fix. 
You don't need to modify the v32v2 utility. Rather, the fix involves how the 
RSL library is built on the Linux machines.  Could you please try the 
following?

  1.  cd MPP/RSL/RSL

  2.  Edit the file: makefile.linux and add change
      the CFLAGS line so that it reads:

CFLAGS = -I$(IDIR) -DMPI -DRSL_SYNCIO -Dlinux -DSWAPBYTES -O

      In other words, add the -DSWAPBYTES option.

  3.  make clean ; rm librsl.a

  4.  setenv LINUX_MPIHOME /usr/local/mpich ; make linux

  5.  cd ../../..

  6.  rm Run/mm5.mpp

  7.  make mpp

Then please try the resulting executable and see if it generates output that is 
compatible with v32v2 utility. Please let me know either way if this fixes the 
problem, since I expect that other linux users may run into this trouble too.

Something similar was necessary for the MPP version on the Compaq Alpha 
machines (see MPP/RSL/RSL/makefile.alpha), which -- like the PC linux machines 
-- are native little-endian.

Thanks for the report. I am adding a note on this to the 
http://www.mmm.ucar.edu/mm5/mpp/helpdesk and cc'ing a number of other Linux MPP 
users. Note that this involves only Version 3.  I believe that Version 2 is 
unaffected by this.

John

-----------------------------------------------------------
John Michalakes  | Argonne NL/MCS Div. | NCAR MMM Div.
[email-masked]                      | 3450 Mitchell Lane
http://www.mcs.anl.gov/~michalak       | Boulder, CO 80301
phone: 303-497-8199  fax: 303-497-8181
-----------------------------------------------------------